// DemoFP.h : Declaration of the CDemoFP

#ifndef __DEMOFP_H_
#define __DEMOFP_H_

#include "resource.h"       // main symbols


/////////////////////////////////////////////////////////////////////////////
// CDemoFP
class ATL_NO_VTABLE CDemoFP : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CDemoFP, &CLSID_DemoFP>,
	public CComControl<CDemoFP>,
	public CStockPropImpl<CDemoFP, IWlogDemoFP, &IID_IWlogDemoFP, &LIBID_WLOGRIGDEMOLib>,
	public IProvideClassInfo2Impl<&CLSID_DemoFP, NULL, &LIBID_WLOGRIGDEMOLib>,
	public IPersistStreamInitImpl<CDemoFP>,
	public IPersistStorageImpl<CDemoFP>,
	public IQuickActivateImpl<CDemoFP>,
	public IOleControlImpl<CDemoFP>,
	public IOleObjectImpl<CDemoFP>,
	public IOleInPlaceActiveObjectImpl<CDemoFP>,
	public IViewObjectExImpl<CDemoFP>,
	public IOleInPlaceObjectWindowlessImpl<CDemoFP>,
	public IDataObjectImpl<CDemoFP>,
	public ISpecifyPropertyPagesImpl<CDemoFP>
{
public:
	CDemoFP()
	{
 
	}

DECLARE_REGISTRY_RESOURCEID(IDR_DEMOFP)

BEGIN_COM_MAP(CDemoFP)
	COM_INTERFACE_ENTRY(IWlogDemoFP)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IMPL(IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject2, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject, IViewObjectEx)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleInPlaceObject, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY_IMPL(IOleControl)
	COM_INTERFACE_ENTRY_IMPL(IOleObject)
	COM_INTERFACE_ENTRY_IMPL(IQuickActivate)
	COM_INTERFACE_ENTRY_IMPL(IPersistStorage)
	COM_INTERFACE_ENTRY_IMPL(IPersistStreamInit)
	COM_INTERFACE_ENTRY_IMPL(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY_IMPL(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROPERTY_MAP(CDemoFP)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	PROP_PAGE(CLSID_StockColorPage)
END_PROPERTY_MAP()


BEGIN_MSG_MAP(CDemoFP)
	MESSAGE_HANDLER(WM_PAINT, OnPaint)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_KILLFOCUS, OnKillFocus)
END_MSG_MAP()


// IViewObjectEx
	STDMETHOD(GetViewStatus)(DWORD* pdwStatus)
	{
		ATLTRACE(_T("IViewObjectExImpl::GetViewStatus\n"));
		*pdwStatus = VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE;
		return S_OK;
	}

// IWlogDemoFP
public:
	STDMETHOD(SetRig)(/*[in]*/ IUnknown *pRig);
	STDMETHOD(GetFpWidthAndHeight)(/*[in,out]*/ long *pWidth, /*[in,out]*/ long *pHeight);
	HRESULT OnDraw(ATL_DRAWINFO& di);

	OLE_COLOR m_clrBackColor;

protected:
	// WriteLog will set us up to talk to the rig driver...
	CComQIPtr<IKachina, &IID_IKachina>	m_pRig;
};

#endif //__DEMOFP_H_
