/*
** Copyright (c) 1992, 1993-2001 by Wayne E. Wright, W5XD, Round Rock, Texas
** All rights reserved.
*/
// RigManager.cpp : Implementation of CRigManager
#include "stdafx.h"
#include "WlogRigs.h"
#include "WlogRigLib.h"
#include "RigManager.h"
#include "RigDisp.h"
#include "Rig.h"
#include "DrvTable.h"
#include "RwRig.h"
/////////////////////////////////////////////////////////////////////////////
// CRigManager

extern "C" struct DrvTable *(DrvTblArray[]);


CRigManager::~CRigManager()
{
		RigCloseLog();
}

STDMETHODIMP CRigManager::get_Count(long * pVal)
{
	*pVal = rig_dispMax()+1;
	return S_OK;
}

STDMETHODIMP CRigManager::get_Label(long Index, BSTR * pVal)
{
	CComBSTR	Bstr;
	*pVal = 0;
	if ((Index < 0) || (Index > rig_dispMax()))
		return E_INVALIDARG;
	Bstr = rig_dispLabel(Index);
	*pVal = Bstr.Detach();
	return S_OK;
}

STDMETHODIMP CRigManager::GetRigObject(long Index, IWlRig * * pRig)
{
	HRESULT  hr = E_FAIL;
	*pRig = 0;
	if ((Index < 0) || (Index > rig_dispMax()))
		return E_INVALIDARG;
	
	FactoryFcn_t *f = (DrvTblArray[Index]->ObjectFactory);
	if (f)
	{
		hr = (*f)(Index, pRig);
	}
	return hr;
}


STDMETHODIMP CRigManager::get_Baud(long Index, long * pVal)
{
	if ((Index < 0) || (Index > rig_dispMax()))
		return E_INVALIDARG;
	*pVal = rig_dispBaud(Index);
	return S_OK;
}
