/*
** Copyright (c) 1992, 1993-2001 by Wayne E. Wright, W5XD, Round Rock, Texas
** All rights reserved.
*/
// RigManager.h : Declaration of the CRigManager

#ifndef __RIGMANAGER_H_
#define __RIGMANAGER_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CRigManager
//
// WriteLog calls on this implementation to find out what rigs this
// particular rig driver supports. This implementation is table driven.
class ATL_NO_VTABLE CRigManager : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CRigManager, &CLSID_RigManager>,
	public IRigManager
{
public:
	CRigManager()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_RIGMANAGER)
DECLARE_NOT_AGGREGATABLE(CRigManager)

BEGIN_COM_MAP(CRigManager)
	COM_INTERFACE_ENTRY(IRigManager)
END_COM_MAP()

// IRigManager
public:
	STDMETHOD(get_Baud)(/*[in]*/ long Index, /*[out, retval]*/ long *pVal);
	STDMETHOD(GetRigObject)(/*[in]*/long Index, /*[out]*/ IWlRig **pRig);
	STDMETHOD(get_Label)(long Index, /*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_Count)(/*[out, retval]*/ long *pVal);

protected:
	~CRigManager();
};

#endif //__RIGMANAGER_H_
